import java.util.ArrayList;
import java.util.Arrays;

public class KanjiBlankData {
	//----------萔------------
	//
	static final int DEF_HEIGHT=8;
	static final int DEF_WIDTH=4;
	static final int DEF_CHAR_MAX=4;
	//words,overlapChar
	static final char CHAR_OVERLAP='';
	static final char CHAR_EMPTY='';
	//overlapNum
	static final int INT_NOT_OVERLAP=0;
	static final int INT_NO_CHAR=-1;
	//----------ϐ------------
	//TCY
	int height,width,charMax;
	//n
	String[] words;
	int[][] overlapNum;
	//d
	ArrayList<Character> overlapChar;
	//G[
	ArrayList<KanjiBlankError> errors=new ArrayList<KanjiBlankError>();
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KanjiBlankData(){
		formatPuzzle(DEF_HEIGHT,DEF_WIDTH,DEF_CHAR_MAX);
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	//wTCYŐVpY쐬
	public void formatPuzzle(int ht,int wd,int chMx){
		height=ht;
		width=wd;
		charMax=chMx;
		words=new String[getTotalNum()];
		overlapNum=new int[getTotalNum()][charMax];
		overlapChar=new ArrayList<Character>();
		for(int t=0;t<getTotalNum();t++){
			words[t]=String.valueOf(CHAR_EMPTY);
			for(int c=0;c<charMax;c++){
				overlapNum[t][c]=INT_NO_CHAR;
			}
		}
	}
	//݂̃f[^̂܂܎cāAwTCYɕύX
	public String changePuzzle(int ht,int wd,int chMx){
		//nꐔ`FbN
		if(ht*wd<getTotalNum()){
			for(int t=ht*wd;t<getTotalNum();t++){
				if(overlapNum[t][0]!=INT_NO_CHAR){
					return "w͈̔͊OɏnꂪcĂ܂B";
				}
			}
		}
		//ő啶`FbN
		if(chMx<charMax){
			for(int t=0;t<getTotalNum();t++){
				if(overlapNum[t][chMx]!=INT_NO_CHAR){
					return "w̕𒴂nꂪ܂B";
				}
			}
		}
		//wTCŸꎞϐɈړƒǉ
		String[] tmpWords=new String[ht*wd];
		int[][] tmpOverlapNum=new int[ht*wd][chMx];
		if(ht*wd<getTotalNum()){
			if(chMx<charMax){
				for(int t=0;t<ht*wd;t++){
					tmpWords[t]=words[t];
					for(int c=0;c<chMx;c++){
						tmpOverlapNum[t][c]=overlapNum[t][c];
					}
				}
			}else{
				for(int t=0;t<ht*wd;t++){
					tmpWords[t]=words[t];
					for(int c=0;c<charMax;c++){
						tmpOverlapNum[t][c]=overlapNum[t][c];
					}
					for(int c=charMax;c<chMx;c++){	//ǉ
						tmpOverlapNum[t][c]=INT_NO_CHAR;
					}
				}
			}
		}else{
			if(chMx<charMax){
				for(int t=0;t<getTotalNum();t++){
					tmpWords[t]=words[t];
					for(int c=0;c<chMx;c++){
						tmpOverlapNum[t][c]=overlapNum[t][c];
					}
				}
				for(int t=getTotalNum();t<ht*wd;t++){	//ǉ
					tmpWords[t]=String.valueOf(CHAR_EMPTY);
					for(int c=0;c<chMx;c++){
						tmpOverlapNum[t][c]=INT_NO_CHAR;
					}
				}
			}else{
				for(int t=0;t<getTotalNum();t++){
					tmpWords[t]=words[t];
					for(int c=0;c<charMax;c++){
						tmpOverlapNum[t][c]=overlapNum[t][c];
					}
					for(int c=charMax;c<chMx;c++){	//ǉ
						tmpOverlapNum[t][c]=INT_NO_CHAR;
					}
				}
				for(int t=getTotalNum();t<ht*wd;t++){	//ǉ
					tmpWords[t]=String.valueOf(CHAR_EMPTY);
					for(int c=0;c<chMx;c++){
						tmpOverlapNum[t][c]=INT_NO_CHAR;
					}
				}
			}
		}
		//Ă͂
		height=ht;
		width=wd;
		charMax=chMx;
		words=tmpWords;
		overlapNum=tmpOverlapNum;
		//
		return null;
	}
	//𓚏idSăJɂj
	public void formatAnswer(){
		for(int o=0;o<overlapChar.size();o++){
			overlapChar.set(o, CHAR_EMPTY);
		}
	}
	//d̐iO`PxgȂd폜j
	public String removeOverlapChar(){
		int c0d=0;
		int c1d=0;
		int c1l=0;
		//-----------------------------------------
		//d̎gp񐔃`FbN\
		int[] useCh=countOvCharUseTimes();
		//-----------------------------------------
		//wԍ̕ϊe[u
		int[] newNum=new int[overlapChar.size()];
		int num=0;
		//
		for(int o=0;o<overlapChar.size();o++){
			if(useCh[o]>=2){				//QȏȂ
				num++;
				newNum[o]=num;
			}else if(useCh[o]==1){			//P
				if(overlapChar.get(o).equals( CHAR_EMPTY )){	//wȂAc
					num++;
					newNum[o]=num;
					//
					c1l++;
				}else{											//w蕶΁Aꍞō폜
					//numi߂Ȃ
					newNum[o]=INT_NOT_OVERLAP;
					//
					c1d++;
				}
			}else{							//OȂ폜
				//numi߂Ȃ
				newNum[o]=INT_NO_CHAR;
				//
				c0d++;
			}
		}
		//-----------------------------------------
		//s
		if(num<overlapChar.size()){
			//nꒆ̎wԍϊ
loopT:		for(int t=0;t<getTotalNum();t++){
				for(int c=0;c<charMax;c++){
					//
					switch(overlapNum[t][c]){
					case INT_NOT_OVERLAP:
						break;
					case INT_NO_CHAR:
						continue loopT;
					default:
						//d̒PƎgpieꍇňÂj
						if(newNum[overlapNum[t][c]-1]==INT_NOT_OVERLAP){
							//
							words[t]=replaceCharAt(words[t],c,overlapChar.get(overlapNum[t][c]-1));
							overlapNum[t][c]=INT_NOT_OVERLAP;
							//̕
							continue;
						}
						//PƎgpłȂꍇ
						overlapNum[t][c]=newNum[overlapNum[t][c]-1];
						break;
					}
				}
			}
			//d폜irō폜Ă̂Ń}CiXɁj
			for(int o=overlapChar.size()-1;o>=0;o--){
				if(newNum[o]==INT_NOT_OVERLAP || newNum[o]==INT_NO_CHAR){
					overlapChar.remove(o);
				}
				
			}
		}
		//-----------------------------------------
		//ʂ̏o
		StringBuilder ret=new StringBuilder();
		if(c0d>0){
			ret.append("gp̏d ").append(c0d).append(" A폜܂B\n\n");
		}
		if(c1d>0){
			if(c1l>0){
				ret.append("PƎgp̏d ").append(c1d+c1l).append(" A\n");
				ret.append("@m肵Ă ").append(c1d).append(" A폜܂B\n");
				ret.append("@m ").append(c1l).append(" ́AΉł܂łB\n");
			}else{
				ret.append("PƎgp̏d ").append(c1d+c1l).append(" A\n");
				ret.append("@m肵Ă ").append(c1d).append(" A폜܂B\n");
			}
		}else{
			if(c1l>0){
				ret.append("PƎgp̏d ").append(c1d+c1l).append(" A\n");
				ret.append("@m ").append(c1l).append(" ́AΉł܂łB\n");
			}
		}
		//
		if(ret.length()==0){	//G[
			return null;
		}else{					//G[L
			return ret.toString();
		}
	}
	//d̎gp񐔁iG[odetectError()Ă΂j
	private int[] countOvCharUseTimes(){
		//d̎gp񐔃`FbN\
		int[] useCh=new int[overlapChar.size()];
		for(int u=0;u<overlapChar.size();u++){
			useCh[u]=0;
		}
		//`FbNs
loopT:	for(int t=0;t<getTotalNum();t++){
			for(int c=0;c<charMax;c++){
				switch(overlapNum[t][c]){
				case INT_NOT_OVERLAP:
					break;
				case INT_NO_CHAR:
					continue loopT;
				default:
					useCh[overlapNum[t][c]-1]++;
					break;
				}
			}
		}
		//
		return useCh;
	}
	//******************************************************************************************************
	//G[
	//------------------------------------------------------------------------------------------------------
	//o
	public void detectError(){
		//
		removeError();
		//nꂪ́
		for(int t=0;t<getTotalNum();t++){
			if(words[t].equals( String.valueOf(CHAR_EMPTY) )){
				errors.add(new KanjiBlankError(-t-1,0,KanjiBlankError.ER_NO_INPUT_WARD));
			}
		}
		//
		//dXg
		ArrayList<Character> nonOvCh=new ArrayList<Character>();
		ArrayList<Integer> nonOvChWd=new ArrayList<Integer>();
		//
/*loopT:*/for(int t=0;t<getTotalNum();t++){
			//
			if(words[t].equals(String.valueOf(CHAR_EMPTY))){	continue;	}
			//nꁄ
			for(int t2=t+1;t2<getTotalNum();t2++){
				if(words[t2].equals(words[t]) && Arrays.equals(overlapNum[t], overlapNum[t2])){
					errors.add(new KanjiBlankError(-t-1,-t2-1,KanjiBlankError.ER_SAME_WARD));
				}
			}
			//d̂Ȃnꁄ
			if(words[t].indexOf(CHAR_OVERLAP)==-1){
				errors.add(new KanjiBlankError(-t-1,0,KanjiBlankError.ER_NO_OVERLAP_WARD));
			}
			//dXg쐬
			for(int c=0;c<charMax;c++){
				if(overlapNum[t][c]==INT_NOT_OVERLAP){
					nonOvCh.add(words[t].charAt(c));
					nonOvChWd.add(t);
					//id̊Ԃł̏d͓͎Ƀ`FbN͂j
				}
				/*
				switch(overlapNum[t][c]){
				case INT_NOT_OVERLAP:
					nonOvCh.add(words[t].charAt(c));
					nonOvChWd.add(t);
					//id̊Ԃł̏d͓͎Ƀ`FbN͂j
					break;
				case INT_NO_CHAR:
					continue loopT;
				default:
					//no work
				}*/
			}
		}
		//
		for(int o=0;o<overlapChar.size();o++){
			if(overlapChar.get(o).equals( CHAR_EMPTY )){
				//d͂ĂȂ
				errors.add(new KanjiBlankError(o+1,0,KanjiBlankError.ER_NO_INPUT_CHAR));
			}else{
				//dƓd遄
				for(int n=0;n<nonOvCh.size();n++){
					if(overlapChar.get(o).equals( nonOvCh.get(n) )){
						errors.add(new KanjiBlankError(o+1,-nonOvChWd.get(n)-1,KanjiBlankError.ER_SAME_WARD_CHAR));
					}
				}
			}
			//id͓͎ɂ͂͂j
		}
		//ȏgĂȂd
		int[] useCh=countOvCharUseTimes();
		for(int u=0;u<useCh.length;u++){
			if(useCh[u]<2){
				errors.add(new KanjiBlankError(u+1,0,KanjiBlankError.ER_NO_OVERLAP_CHAR));
			}
		}
	}
	//ʕ\̕
	public String getErrorInfo(){
		StringBuilder ret=new StringBuilder();
		//
		if(errors.size()==0){
			ret.append("G[͂܂B");
		}else{
			int[] num=new int[KanjiBlankError.ER_MAX];
			for(int n=0;n<KanjiBlankError.ER_MAX;n++){
				num[n]=0;
			}
			//eG[̉
			for(int e=0;e<errors.size();e++){
				num[errors.get(e).type]++;
			}
			//
			for(int n=0;n<KanjiBlankError.ER_MAX;n++){
				if(num[n]>0){
					switch(n){
					case KanjiBlankError.ER_NO_INPUT_WARD:
						ret.append("͂̏nꂪ ").append(num[n]).append(" ܂B\n");
						break;
					case KanjiBlankError.ER_NO_INPUT_CHAR:
						ret.append("͂̏d ").append(num[n]).append(" ܂B\n");
						break;
					case KanjiBlankError.ER_NO_OVERLAP_WARD:
						ret.append("d̂Ȃnꂪ ").append(num[n]).append(" ܂B\n");
						break;
					case KanjiBlankError.ER_NO_OVERLAP_CHAR:
						ret.append("dĂȂd ").append(num[n]).append(" ܂B\n");
						break;
					case KanjiBlankError.ER_SAME_WARD:
						ret.append("nꂪ ").append(num[n]).append(" ܂B\n");
						break;
					case KanjiBlankError.ER_SAME_WARD_CHAR:
						ret.append("n̔dƓd ").append(num[n]).append(" ܂B\n");
						break;
					}
				}
			}
		}
		//
		return ret.toString();
	}
	//폜
	public void removeError(){
		errors.clear();
	}
	//******************************************************************************************************
	//͗output
	//------------------------------------------------------------------------------------------------------
	//nin͔zCfbNXdlj
	public String getWords(int n){
		StringBuilder ret=new StringBuilder();
		for(int c=0;c<charMax;c++){
			if(overlapNum[n][c]==INT_NOT_OVERLAP){		//d͂̂܂
				ret.append(words[n].charAt(c));
			}else if(overlapNum[n][c]==INT_NO_CHAR){	//񂪏IĂΏI
				break;
			}else{										//d
				if(overlapChar.get(overlapNum[n][c]-1)==CHAR_EMPTY){	//ȂΎwԍ
					ret.append("[").append(overlapNum[n][c]).append("]");
				}else{													//Ε
					ret.append(overlapChar.get(overlapNum[n][c]-1));
				}
			}
		}
		return ret.toString();
	}
	//din͔zCfbNXdlj
	public String getOverlapChar(int n){
		if(overlapChar.get(n).equals( CHAR_EMPTY )){
			return "";
		}else{
			return String.valueOf(overlapChar.get(n));
		}
	}
	//******************************************************************************************************
	//͗input
	//------------------------------------------------------------------------------------------------------
	//nin͔zCfbNXdljA𓚃[h
	public String setWordAnswer(String str,int n){		//𓚃[hł́A`FbN
		//-----------------------------------------
		//Vf[^𕪐
		//S|PDԍ̕ƒu
		StringBuilder strBld=new StringBuilder(str);
		//
		ArrayList<Integer> intAry=new ArrayList<Integer>();
		//
		int st=0,ed=0;
		do{
			st=strBld.indexOf("[",st);
			if(st!=-1){
				ed=strBld.indexOf("]",ed);
				if(ed==-1 || st>=ed-1){ return "[ ]̎w肪܂B";	}	//
				//
				try{
					//wԍ𕪗
					int ret=Integer.parseInt(strBld.substring(st+1, ed));
					intAry.add(ret);
					//ԍw蕔𕶎萔ɒu
					strBld=strBld.replace(st, ed+1, String.valueOf(CHAR_OVERLAP) );
				}catch(NumberFormatException exc){	return "[ ]͐w肵ĂB";	}	//
			}else{
				break;	//ԍȂΏI
			}
		}while(true);
		//ő啶𒴂ĂΕs
		if(strBld.length()>charMax){
			return "܂B";
		}
		//S|QDi`FbNƁjԍ\́ij쐬
		int[] overN=new int[charMax];	//ő啶
		int in=0;
		for(int s=0;s<strBld.length();s++){
			if(strBld.charAt(s)!=CHAR_OVERLAP){
				//i`FbN͂Ȃj
				//
				overN[s]=INT_NOT_OVERLAP;
			}else{
				//ĂwԍԂɓ
				overN[s]=intAry.get(in);
				in++;
			}
		}
		//(ő啶܂Ŗ߂Kv͂Ȃ)
		//
		//-----------------------------------------
		//
		if(words[n].equals(String.valueOf(CHAR_EMPTY))){
			return "n̒ǉ͕ҏW[hōsĂB";
		}
		//
		int len=words[n].length();
		if(len!=strBld.length()){
			return "v܂B";
		}
		//
		boolean[] change=new boolean[len];
		for(int c=0;c<len;c++){
			char preC=getCharAt(n,c);
			char postC=strBld.charAt(c);
			//
			if(preC==CHAR_EMPTY){
				if(postC==CHAR_OVERLAP){	//ŵ܂
					//id̎wԍ`FbŃAĂĂj
					change[c]=false;
				}else{					//VɎw
					change[c]=true;
				}
			}else{
				if(postC==preC){		//w肪ς炸
					change[c]=false;
				}else{					//w肪ύXĂ
					return "͍ς݂͕̕ύXł܂B";
				}
			}
		}
		for(int c=0;c<len;c++){
			if(change[c]){
				//dȂ`FbN
				for(int o=0;o<overlapChar.size();o++){
					if(strBld.charAt(c)==overlapChar.get(o)){
						//inɂ͕̓ȏoĂꍇAG[ɂȂ̂hj
						if(o!=overlapNum[n][c]-1){
							return "d܂B";
						}
					}
				}
				//
				overlapChar.set(overlapNum[n][c]-1, strBld.charAt(c));
			}
		}
		//
		return null;
	}
	private char getCharAt(int n,int c){	//
		if(words[n].charAt(c)==CHAR_OVERLAP){
			return overlapChar.get(overlapNum[n][c]-1);
		}else{
			return words[n].charAt(c);
		}
	}
	//nin͔zCfbNXdljA̓[h
	public String setWordEdit(String str,int n){	//̓[hł́Aɓւ
		//Xf[^͒uŏĂ
		//id̎gp񐔂0`1ɂȂ邩ȂÂ܂܁j
		//idXgێꍇ͍폜KvɂȂj
		//
		//-----------------------------------------
		//Vf[^𕪐
		//S|PDԍ̕ƒu
		StringBuilder strBld=new StringBuilder(str);
		//
		ArrayList<Integer> intAry=new ArrayList<Integer>();
		//wԍI[o[̂`FbN
		int ovChMx=overlapChar.size();
		//
		int st=0,ed=0;
		do{
			st=strBld.indexOf("[",st);
			if(st!=-1){
				ed=strBld.indexOf("]",ed);
				if(ed==-1 || st>=ed-1){ return "[ ]̎w肪܂B";	}	//
				//
				try{
					//wԍ𕪗
					int ret=Integer.parseInt(strBld.substring(st+1, ed));
					intAry.add(ret);
					//d̍őԍ̍XV
					if(ret>ovChMx){	ovChMx=ret;	}
					//ԍw蕔𕶎萔ɒu
					strBld=strBld.replace(st, ed+1, String.valueOf(CHAR_OVERLAP) );
				}catch(NumberFormatException exc){	return "[ ]͐w肵ĂB";	}	//
			}else{
				break;	//ԍȂΏI
			}
		}while(true);
		//ő啶𒴂ĂΕs
		if(strBld.length()>charMax){
			return "܂BKvȂő啶𑝂₵ĂB";
		}
		//wԍI[o[ĂΏde[ugi[v邪Awԍł炳Ȃ߂ɂōsj
		for(int o=overlapChar.size();o<ovChMx;o++){
			overlapChar.add(CHAR_EMPTY);
		}
		//S|QD`FbNƔԍ\́ij쐬
		int[] overN=new int[charMax];	//ő啶
		int in=0;
loopS:	for(int s=0;s<strBld.length();s++){
			if(strBld.charAt(s)!=CHAR_OVERLAP){
				//de[uɊ܂܂ĂȂ
				for(int o=0;o<overlapChar.size();o++){
					if(strBld.charAt(s)==overlapChar.get(o)){
						//
						strBld.setCharAt(s,CHAR_OVERLAP);
						overN[s]=o+1;
						//̕
						continue loopS;
					}
				}
				//dɊ܂܂ĂȂ				idXgێĂׂHj
				for(int w=0;w<getTotalNum();w++){
					//i̕ʂɂ܂œ͂Ăn`FbNɉĂ͂Ȃj
					if(w==n){	continue;	}
					//
					for(int c=0;c<charMax;c++){
						if(overlapNum[w][c]==INT_NOT_OVERLAP){
							if(words[w].charAt(c)==strBld.charAt(s)){
								//
								//dɒǉ
								overlapChar.add(words[w].charAt(c));			//iwԍ邩ȂAdȂj
								//d̏o
								words[w]=replaceCharAt(words[w],c,CHAR_OVERLAP);
								overlapNum[w][c]=overlapChar.size();
								//Vf[^̏o
								strBld.setCharAt(s,CHAR_OVERLAP);
								overN[s]=overlapChar.size();
								//̕
								continue loopS;
							}
						}
					}
				}
				//̏nꎩ̂ɕ܂܂ĂȂ
				for(int s2=s+1;s2<strBld.length();s2++){
					if(strBld.charAt(s2)==strBld.charAt(s)){
						//dɒǉ
						overlapChar.add(strBld.charAt(s));			//iwԍ邩ȂAdȂj
						//ڂ̏o
						strBld.setCharAt(s,CHAR_OVERLAP);
						overN[s]=overlapChar.size();
						//iڈȍ~͏de[uňB
						//	ĂwԍĂۂɏԂȂȂ悤Ɂj
						//̕
						continue loopS;
					}
				}
				//܂܂ĂȂ
				overN[s]=INT_NOT_OVERLAP;
			}else{
				//ĂwԍԂɓ
				overN[s]=intAry.get(in);
				in++;
			}
		}
		//sĂ΍ő啶܂Ŗ߂
		for(int s=strBld.length();s<charMax;s++){
			overN[s]=INT_NO_CHAR;
		}
		//J񂾂ꍇ́A\萔ɂiŏɔ肵ďĂ܂ׂHj
		if(strBld.length()==0){
			strBld.append(String.valueOf(CHAR_EMPTY));
		}
		//-----------------------------------------
		//ԍ\o^
		overlapNum[n]=overN;
		//no^
		words[n]=strBld.toString();
		//
		return null;
	}
	//din͔zCfbNXdlj
	public String setOverlapChar(String str,int n){
		if(str.length()>1){				//͕s
			return "Pœ͂ĂB";
		}else if(str.length()==0){		//
			overlapChar.set(n, CHAR_EMPTY);
		}else{							//̕
			//dȂ`FbN
			for(int o=0;o<overlapChar.size();o++){
				//͈ʒuɌX̓`FbNȂĂ
				if(o==n){	continue;	}
				//
				if(str.charAt(0)==overlapChar.get(o)){
					return "d܂B";
				}
			}
			//
			overlapChar.set(n, str.charAt(0));
		}
		//idƓ̂͂邩ȂÂ܂܁j
		//
		return null;
	}
	//******************************************************************************************************
	//}EXhbOŏԂւ
	//------------------------------------------------------------------------------------------------------
	//ni͔zCfbNXdlj
	public void moveWord(int from,int to){
		String tmpWord=words[from];
		int[] tmpOverlapNum=overlapNum[from];
		if(from<to){
			for(int m=from;m<to;m++){
				words[m]=words[m+1];
				overlapNum[m]=overlapNum[m+1];
			}
		}else if(from>to){
			for(int m=from;m>to;m--){
				words[m]=words[m-1];
				overlapNum[m]=overlapNum[m-1];
			}
		}
		words[to]=tmpWord;
		overlapNum[to]=tmpOverlapNum;
	}
	//di͔zCfbNXdlj
	public void moveOverlapChar(int from,int to){
		//-----------------------------------------
		//d̏Ԃւ
		char tmpC=overlapChar.get(from);
		overlapChar.remove(from);
		overlapChar.add(to,tmpC);	//fromtôǂ炪傫ĂAł
		//-----------------------------------------
		//wԍ̕ϊe[u
		int[] tbl=new int[overlapChar.size()];
		for(int t=0;t<tbl.length;t++){
			tbl[t]=t;
		}
		if(from<to){
			tbl[from]=to;
			for(int t=from+1;t<=to;t++){
				tbl[t]=t-1;
			}
		}else if(from>to){
			tbl[from]=to;
			for(int t=from-1;t>=to;t--){
				tbl[t]=t+1;
			}
		}
		//n̏d̎wԍւ
		for(int t=0;t<getTotalNum();t++){
			for(int c=0;c<charMax;c++){
				if(overlapNum[t][c]==INT_NOT_OVERLAP){
					//
				}else if(overlapNum[t][c]==INT_NO_CHAR){
					break;
				}else{
					overlapNum[t][c]=tbl[overlapNum[t][c]-1]+1;
				}
			}
		}
	}
	//******************************************************************************************************
	//[h
	//------------------------------------------------------------------------------------------------------
	public String setLoadString(String[] ld){
		//ꎞIɊi[imF̂߁j
		int tmpHeight,tmpWidth,tmpCharMax;
		String[] tmpWords;
		int[][] tmpOverlapNum;
		ArrayList<Character> tmpOverlapChar;
		
		//
		String[] sp;
		//-----------------------------------------
		//PDc
		tmpHeight=ld.length;	//lisȂΑSscj
		for(int s=0;s<ld.length;s++){
			if(ld[s].replace(",","").length()==0){	//J񂩃J}݂̂̏ꍇ
				tmpHeight=s;	//s܂ł̍sc
				break;
			}
		}
		//-----------------------------------------
		//QDiPsڂ𒲂ׂj
		sp=ld[0].split(",");
		tmpWidth=sp.length;		//li}XȂΑS}Xcj
		for(int s=0;s<sp.length;s++){
			if(sp[s].length()==0){
				tmpWidth=s;		//}X܂ł̃}X
				break;
			}
		}
		//-----------------------------------------
		//RDde[uij
		tmpOverlapChar=new ArrayList<Character>();
		if(ld.length>=tmpHeight+2){
			sp=ld[tmpHeight+1].split(",");
			for(int s=0;s<sp.length;s++){
				if(sp[s].length()==1){
					tmpOverlapChar.add(sp[s].charAt(0));		//PȂ͂𑱂iCHAR_EMPTY܂ށj
				}else if(sp[s].length()==0){
					break;										//OoΏI
				}else{
					return "d͈ꕶłȂ΂܂B";	//Qȏ̓G[
				}
			}
		}
		//do^ĂȂ
		for(int o1=0;o1<tmpOverlapChar.size();o1++){
			if(tmpOverlapChar.get(o1)!=CHAR_EMPTY){
				for(int o2=o1+1;o2<tmpOverlapChar.size();o2++){
					if(tmpOverlapChar.get(o1).equals(tmpOverlapChar.get(o2))){
						return "d܂B";
					}
				}
			}
		}
		//-----------------------------------------
		//SDne[u
		int ovChMx=0;
		int[][] tmpTmpOverlapNum=new int[tmpHeight*tmpWidth][/*s*/];
		tmpCharMax=0;
		tmpWords=new String[tmpHeight*tmpWidth];
		for(int h=0;h<tmpHeight;h++){
			sp=ld[h].split(",");
			if(sp.length<tmpWidth){ return "n̉̌sĂ܂B";	}
			//
			for(int w=0;w<tmpWidth;w++){
				//
				if(sp[w].equals("")){											//CHAR_EMPTYȂꍇ̓G[
					return "n̑ݎw肪Ă܂B";
				}else if(sp[w].equals(String.valueOf(CHAR_EMPTY))){				//͖iCHAR_EMPTYj
					tmpTmpOverlapNum[w*tmpHeight+h]=null;
					//
					tmpWords[w*tmpHeight+h]=String.valueOf(CHAR_EMPTY);
				}else{															//͗L
					//S|PDԍ̕ƒu
					StringBuilder strBld=new StringBuilder(sp[w]);
					//
					ArrayList<Integer> intAry=new ArrayList<Integer>();
					//
					int st=0,ed=0;
					do{
						st=strBld.indexOf("[",st);
						if(st!=-1){
							ed=strBld.indexOf("]",ed);
							if(ed==-1 || st>=ed-1){ return "[ ]̎w肪܂B";	}
							//
							try{
								//wԍ𕪗
								int ret=Integer.parseInt(strBld.substring(st+1, ed));
								intAry.add(ret);
								//d̍őԍ̍XV
								if(ret>ovChMx){	ovChMx=ret;	}
								//ԍw蕔𕶎萔ɒu
								strBld=strBld.replace(st, ed+1, String.valueOf(CHAR_OVERLAP) );
							}catch(NumberFormatException exc){	return "[ ]͐w肵ĂB";	}
						}else{
							break;	//ԍȂΏI
						}
					}while(true);
					//S|QD`FbNƔԍ\̉쐬
					int[] overN=new int[strBld.length()];
					int in=0;
loopS:				for(int s=0;s<strBld.length();s++){
						if(strBld.charAt(s)!=CHAR_OVERLAP){
							//de[uɊ܂܂ĂȂ
							for(int o=0;o<tmpOverlapChar.size();o++){
								if(strBld.charAt(s)==tmpOverlapChar.get(o)){
									//
									strBld.setCharAt(s,CHAR_OVERLAP);
									overN[s]=o+1;
									//̕
									continue loopS;
								}
							}
							//܂܂ĂȂ
							overN[s]=INT_NOT_OVERLAP;
						}else{
							//ĂwԍԂɓ
							overN[s]=intAry.get(in);
							in++;
						}
					}
					//̔ԍ\o^
					tmpTmpOverlapNum[w*tmpHeight+h]=overN;
					//n̍ő啶XV
					if(strBld.length()>tmpCharMax){
						tmpCharMax=strBld.length();
					}
					//no^
					tmpWords[w*tmpHeight+h]=strBld.toString();
				}
			}
		}
		//nꂪo^ĂȂΏl
		if(tmpCharMax==0){	tmpCharMax=DEF_CHAR_MAX;	}
		//-----------------------------------------
		//TDԍ\̍蒼
		//
		//wԍI[o[ĂΏde[ugiI[o[Ăꍇ̂ݎsj
		for(int o=tmpOverlapChar.size();o<ovChMx;o++){
			tmpOverlapChar.add(CHAR_EMPTY);
		}
		/*@@@id֋@\ڂj
		//d̎gp񐔃`FbN
		int[] ovChFg=new int[ovChMx];
		for(int f=0;f<ovChMx;f++){
			ovChFg[f]=0;
		}*/
		//o^ĂȂd̃`FbNXg
		ArrayList<Character> arC=new ArrayList<Character>();
		ArrayList<Integer> arWN=new ArrayList<Integer>();
		ArrayList<Integer> arCN=new ArrayList<Integer>();
		//
		tmpOverlapNum=new int[tmpHeight*tmpWidth][tmpCharMax];
		for(int t=0;t<tmpHeight*tmpWidth;t++){
			if(tmpTmpOverlapNum[t]!=null){
				if(tmpTmpOverlapNum[t].length<=tmpCharMax){
					//
loopC:				for(int c=0;c<tmpTmpOverlapNum[t].length;c++){
						//ԍ\ڂ
						tmpOverlapNum[t][c]=tmpTmpOverlapNum[t][c];
						//o^̏d`FbN
						if(tmpOverlapNum[t][c]==INT_NO_CHAR){
							//no workiԍ\ڂcontinueȂj
						}else if(tmpOverlapNum[t][c]==INT_NOT_OVERLAP){
							//ǉd
							for(int a=ovChMx;a<tmpOverlapChar.size();a++){
								if(tmpWords[t].charAt(c)==tmpOverlapChar.get(a)){
									//Oڈȍ~̏o
									tmpWords[t]=replaceCharAt(tmpWords[t],c,CHAR_OVERLAP);
									tmpOverlapNum[t][c]=a+1;
									//̕
									continue loopC;
								}
							}
							//܂łɏodĂȂ
							for(int a=0;a<arC.size();a++){
								if(tmpWords[t].charAt(c)==arC.get(a)){
									//dɒǉ
									tmpOverlapChar.add(tmpWords[t].charAt(c));
									//ڂ̏o
									tmpWords[t]=replaceCharAt(tmpWords[t],c,CHAR_OVERLAP);
									tmpOverlapNum[t][c]=tmpOverlapChar.size();
									//ڂ̏o
									tmpWords[arWN.get(a)]=replaceCharAt(tmpWords[arWN.get(a)],arCN.get(a),CHAR_OVERLAP);
									tmpOverlapNum[arWN.get(a)][arCN.get(a)]=tmpOverlapChar.size();
									//
									arC.remove(a);
									arWN.remove(a);
									arCN.remove(a);
									//̕
									continue loopC;
								}
							}
							//dĂȂ΁AXgɒǉ
							arC.add(tmpWords[t].charAt(c));
							arWN.add(t);
							arCN.add(c);
							
						}else{
							/*@@@id֋@\ڂj
							//dłΎgp񐔂𑝂₷
							ovChFg[tmpOverlapNum[t][c]-1]++;
							*/
							//no work
						}
					}
					//ǉiȕn̕vuő啶v̏ꍇ̂ݎsj
					for(int c=tmpTmpOverlapNum[t].length;c<tmpCharMax;c++){
						tmpOverlapNum[t][c]=INT_NO_CHAR;
					}
				}else{	//NȂ͂
					return "";
				}
			}else{
				for(int c=0;c<tmpCharMax;c++){
					tmpOverlapNum[t][c]=INT_NO_CHAR;
				}
			}
		}
		/*@@@id֋@\ڂj
		//-----------------------------------------
		//UDԍU蒼
		//wԍ̕ϊe[u
		int[] newNum=new int[tmpOverlapChar.size()];
		int num=0;
		//
		for(int f=0;f<ovChMx;f++){
			if(ovChFg[f]>=2){				//QȏȂ
				num++;
				newNum[f]=num;
			}else if(ovChFg[f]==1){			//P
				if(tmpOverlapChar.get(f)==CHAR_EMPTY){
					//numi߂Ȃ
					newNum[f]=INT_NOT_OVERLAP;
				}else{
					return false;
				}
			}else{							//O
				//numi߂Ȃ
				newNum[f]=INT_NO_CHAR;
			}
		}
		//ij
		for(int f=ovChMx;f<tmpOverlapChar.size();f++){
			num++;
			newNum[f]=num;
		}
		//
		if(num<tmpOverlapChar.size()){
			//
			for(int t=0;t<tmpWidth*tmpHeight;t++){
				for(int c=0;c<tmpCharMax;t++){
					int n=tmpOverlapNum[t][c];
					if(newNum[n-1]==INT_NOT_OVERLAP){
						//
						tmpWords[t]=replaceCharAt(tmpWords[t],c,tmpOverlapChar.get(n-1));
						tmpOverlapNum[t][c]=INT_NOT_OVERLAP;
						//
						continue;
					}
					//
					if(n!=INT_NOT_OVERLAP && n!=INT_NO_CHAR){
						tmpOverlapNum[t][c]=newNum[n];
					}
				}
			}
			//
			for(int o=tmpOverlapChar.size()-1;o>=0;o--){
				if(newNum[o]==INT_NOT_OVERLAP || newNum[o]==INT_NO_CHAR){
					tmpOverlapChar.remove(o);
				}
				
			}
		}*/
		//-----------------------------------------
		//VDf[^Ă͂
		width=tmpWidth;
		height=tmpHeight;
		charMax=tmpCharMax;
		overlapNum=tmpOverlapNum;
		//
		words=tmpWords;
		overlapChar=tmpOverlapChar;
		//
		return null;
	}
	//wʒu̕uiStringNXɂ͕uւ郁\bhȂj
	private static String replaceCharAt(String str,int index, char ch){
		StringBuilder strBld=new StringBuilder(str);
		strBld.setCharAt(index, ch);
		return strBld.toString();
	}
	//******************************************************************************************************
	//Z[u
	//------------------------------------------------------------------------------------------------------
	public String getSaveString(){
		//Z[uf[^쐬
		String br=System.getProperty("line.separator");
		StringBuilder ret=new StringBuilder();
		//n
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				String str=words[convert(h,w)];
				for(int c=0;c<str.length();c++){
					switch(str.charAt(c)){
					case CHAR_EMPTY:
						ret.append(str.charAt(c));
						break;
					case CHAR_OVERLAP:
						ret.append("[").append(overlapNum[convert(h,w)][c]).append("]");
						break;
					default:
						ret.append(str.charAt(c));
						break;
					}
				}
				ret.append(",");
			}
			//
			ret.append(br);
		}
		//ԂɉȂs
		ret.append(br);
		//d
		for(int o=0;o<overlapChar.size();o++){
			ret.append(overlapChar.get(o)).append(",");
		}
		ret.append(br);
		//d̉ǐ̂߁if[^͕svj
		for(int o=0;o<overlapChar.size();o++){
			ret.append(o+1).append(",");
		}
		ret.append(br);
		//
		return ret.toString();
	}
	//******************************************************************************************************
	//nz̓Yϊ
	//------------------------------------------------------------------------------------------------------
	//cʂ
	public int convert(int ht,int wd){
		return wd*height+ht;
	}
	//
	public int getTotalNum(){
		return height*width;
	}
	//******************************************************************************************************
	//\[g
	//------------------------------------------------------------------------------------------------------
	public void sortWords(){
		long[] compAr=getComparisonArray();
		//
		quickSort(compAr,0,getTotalNum()-1);
	}
	//NCbN\[hiċNĂяoj
	private void quickSort(long[] compAr,int left,int right){
		//
		if(left>=right){
			return;
		}
		//
		long med=compAr[(int)((left+right)/2)];	//lƂ
		int l=left-1;	//
		int r=right+1;	//
		//
		while(true){
			//Al傫̂T
			do{
				l+=1;
			}while(compAr[l]<med);
			//EAl菬̂T
			do{
				r-=1;
			}while(compAr[r]>med);
			//I
			if(l>=r){
				break;
			}
			//rplւ
			long tmpC=compAr[l];
			compAr[l]=compAr[r];
			compAr[r]=tmpC;
			//nւ
			replaceWord(l,r);
		}
		//ċNĂяo
		quickSort(compAr,left,l-1);		//
		quickSort(compAr,r+1,right);	//E
	}
	//nւ
	private void replaceWord(int l,int r){
		//
		String tmpW=words[l];
		words[l]=words[r];
		words[r]=tmpW;
		//
		int[] tmpOvN=overlapNum[l];
		overlapNum[l]=overlapNum[r];
		overlapNum[r]=tmpOvN;
	}
	//nёւ̔rpɐl
	private long[] getComparisonArray(){
		final int BASE=10;	//ݏ̊inotOvNum傫Ȃ̂ŏł͕sj
		//
		long[] compAr=new long[getTotalNum()];	//ꍇlintł͂Ȃlongɂ
		for(int t=0;t<getTotalNum();t++){
			compAr[t]=0;
		}
		//
		for(int t=0;t<getTotalNum();t++){
			//́i1Ԗڂɑ傫j
			if(overlapNum[t][0]==INT_NO_CHAR){
				compAr[t]+=(int) Math.pow(BASE, charMax+2);
				continue;
			}
			//
			int power=0;	//ݏiɂgj
			int notOvNum=0; //ď
			//i̕قǑ傫j
			for(int c=0;c<charMax;c++){
				switch(overlapNum[t][c]){
				case INT_NO_CHAR:
					//
					continue;
				case INT_NOT_OVERLAP:
					//
					compAr[t]+=(int) Math.pow(BASE, power);
					//
					power++;
					notOvNum++;
					break;
				default:
					//Ȃ
					//
					power++;
				}
			}
			//ďi3Ԗڂɑ傫j
			compAr[t]+=notOvNum*(int) Math.pow(BASE, charMax);
			//i2Ԗڂɑ傫j
			compAr[t]+=power*(int) Math.pow(BASE, charMax+1);
		}
		//
		return compAr;
	}
}
