import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.JarURLConnection;
import java.net.URL;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.event.PrintJobEvent;
import javax.print.event.PrintJobListener;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class KanjiBlankFileIO implements PrintJobListener {
	//Ăяo
	KanjiBlankFrame frame;
	//
	JFileChooser chooser;
	//
	File saveFile,graphicFile,preFile;
	//
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KanjiBlankFileIO(KanjiBlankFrame fr){
		//
		frame=fr;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//
		saveFile=graphicFile=preFile=null;
	}
	//VK쐬ł̏
	public void formatFileName(){
		saveFile=null;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//-------------------------------------------------------------
	//^Cg
	public String getFileName(){
		if(saveFile!=null){
			return saveFile.getName();
		}else{
			return "";
		}
	}
	//******************************************************************************************************
	//[h
	//------------------------------------------------------------------------------------------------------
	public void load(KanjiBlankPanel puzzleField){
		//[ht@C̃pX𓾂
		if(!getTargetFile("Z[ut@C(*.csv)J","J",saveFile,false)){	//[hȂȂI
			return;
		}
		//t@Cǂݍ
		String[] fileString=readTextFile(preFile);
		if(fileString==null){
			frame.showErrorDialog("t@Cǂݍ݂Ɏs܂B");
			return;
		}
		//[hf[^𓖂Ă͂߂
		if(!puzzleField.setLoadString(fileString)){
			frame.showErrorDialog("f[^܂B");
			return;
		}
		//Z[ut@Ci[
		saveFile=preFile;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//******************************************************************************************************
	//Z[u
	//------------------------------------------------------------------------------------------------------
	//㏑ۑ
	public void save(KanjiBlankPanel puzzleField){
		if(saveFile!=null){
			savePuzzleData(saveFile,puzzleField);
		}else{	//Z[ut@C񂪂ȂΖOtĕۑ
			saveAs(puzzleField);
		}
	}
	//Otĕۑ
	public void saveAs(KanjiBlankPanel puzzleField){
		//Z[ut@C̃pX𓾂
		if(getTargetFile("Z[ut@C(*.csv)ɕۑ","ۑ",saveFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"csv");
			//
			savePuzzleData(preFile,puzzleField);
		}
	}
	//Z[ut@C󂯎ăZ[us
	private void savePuzzleData(File file,KanjiBlankPanel puzzleField){
		//Z[us
		if(!writeTextFile(file,puzzleField.getSaveString(true))){
			frame.showErrorDialog("t@C݂Ɏs܂B");
			return;
		}
		//Z[ut@Ci[
		saveFile=preFile;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//******************************************************************************************************
	//摜ۑ
	//------------------------------------------------------------------------------------------------------
	public void outputGraphic(KanjiBlankPanel field){
		//摜
		Dimension dim=field.getPreferredSize();
		BufferedImage image=new BufferedImage(dim.width,dim.height,BufferedImage.TYPE_INT_RGB);
		Graphics g=image.getGraphics();
		g.setColor(Color.WHITE);	//wi𔒂ɂ˂΂ȂȂij
		g.fillRect(0,0,image.getWidth(),image.getHeight());
		//摜ɏ
		field.paintGraphic(image.getGraphics());
		//o͐̉摜t@C̃pX𓾂
		if(getTargetFile("PNG摜(*.png)ɕۑ","ۑ",graphicFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"png");
			//摜ۑs
			try{
				ImageIO.write(image, "png", preFile);
			}catch(IOException ioe){
				frame.showErrorDialog("摜ۑɎs܂B");
				return;
			}
			//t@CXV
			graphicFile=preFile;
		}
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void printField(KanjiBlankPanel field){
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(field,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//****************************_CAO\********************************************
		//̕^Cv (GIFȂ) ̑Zbg (ʂȂ) ł̈T|[gv^[̃Zbg
		PrintService[] printServices=PrintServiceLookup.lookupPrintServices(flavor,pras);
		//v^[I_CAO\
		PrintService service=ServiceUI.printDialog(null,200,200,printServices,defaultService,flavor,pras);
		//Wu쐬
		DocPrintJob job;
		if(service!=null){
			job=service.createPrintJob();
		}else{
			return;
		}
		//*************************************************************************************
		//֘ÃCxg󂯎悤ɂ
		job.addPrintJobListener(this);
		//
		try{
			job.print(doc,pras);
		}catch(PrintException e){
			frame.showErrorDialog("Ɏs܂B");
			return;
		}
	}
	//******************************************************************************************************
	//t@C
	//------------------------------------------------------------------------------------------------------
	//ΏۂƂȂt@C擾i擾trueԂj
	private boolean getTargetFile(String title,String button,File file,boolean overwrite){
		chooser.setSelectedFile(file);
		//
		chooser.setDialogTitle(title);
		//ꎞt@CɎ擾
		File tmpFile;
		while (true) {
			if (chooser.showDialog(frame,button) != JFileChooser.APPROVE_OPTION) {
				return false;
			}
			tmpFile = chooser.getSelectedFile();
			//㏑mFKvȂ炷
			if(!overwrite){	break;	}
			if (tmpFile.exists()) {
				switch (JOptionPane.showConfirmDialog(frame,tmpFile.getName()+" ͊ɑ݂܂B\n㏑܂H","mF",JOptionPane.YES_NO_CANCEL_OPTION)){
					case JOptionPane.YES_OPTION:
						break;
					case JOptionPane.NO_OPTION:
						continue;
					case JOptionPane.CANCEL_OPTION:
						return false;
				}
				break;
			} else {
				break;
			}
		}
		//Ă͂
		preFile=tmpFile;
		return true;
	}
	//t@CɎw肳ꂽgqtĂȂΕtiÓISLAppletDialogĂ΂j
	public static File addExtension(File file,String... extension){
		//gqmF
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			for(int e=0;e<extension.length;e++){
				if(file.getPath().substring(period).equals("."+extension[e])){
					return file;	//̊gqtĂ
				}
			}
			//w肳ꂽgqǂtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}else{	//ŏ牽̊gqtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}
	}
	//******************************************************************************************************
	//eLXgt@Co
	//------------------------------------------------------------------------------------------------------
	//w肳ꂽeLXgt@CǂݍœeԂ
	private static String[] readTextFile(File file){
		try{
			ArrayList<String> stringArray=new ArrayList<String>();
			String line;
			//
			BufferedReader br=new BufferedReader(new FileReader(file));
			while((line=br.readLine())!=null){
				stringArray.add(line);
			}
			br.close();
			//
			String[] ret=new String[stringArray.size()];
			for(int i=0;i<stringArray.size();i++){
				ret[i]=stringArray.get(i);
			}
			return ret;
		}catch(Exception e){
			return null;
		}
	}
	//eLXgf[^t@CɕۑiÓISLAppletDialogĂ΂j
	public static boolean writeTextFile(File file,String data){
		try{
			PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(file)));
			pw.print(data);
			pw.close();
			return true;
		}catch(Exception e){
			return false;
		}
	}
	//******************************************************************************************************
	//Appleto͊֘A
	//------------------------------------------------------------------------------------------------------
	//g܂܂NꂽJARt@CAw̃fBNgɃRs[
	public boolean copySelfJarFile(String parent){
		File selfJar=getSelfJarFile("KanjiBlankPlayer.jar");
		try{
			File target=new File(parent,selfJar.getName());
			if(target.equals(selfJar)){	return true;	}	//fBNgւ̏o͂ȂɎgJAR̂OK
			//
			return copyFile(selfJar,target);
		}catch(IOException ioe){
			return false;
		}
	}
	//g܂܂NꂽJARt@C𓾂
	private File getSelfJarFile(String defFileName){
		try{
			ClassLoader classLoader=this.getClass().getClassLoader();
			URL classURL=classLoader.getResource(this.getClass().getName()+".class");	//NXɊgqt˂΂ȂȂ
			JarURLConnection jarConn=(JarURLConnection)classURL.openConnection();
			URL jarURL=jarConn.getJarFileURL();
			//
			return new File(jarURL.toURI().getPath());
		}catch(Exception e){	//g̓JAR𓾂ȂΒڎw
			return new File(System.getProperty("user.dir")+System.getProperty("file.separator")+defFileName);
		}
	}
	//PɃt@Ccopy
	private static boolean copyFile(File before,File after) throws IOException{
		//t@CmF
		if(!before.exists() || before.isDirectory()){
			return false;
		}
		if(after.isDirectory()){
			return false;
		}
		//copytH_mF
		File dir=after.getParentFile();
		if(!dir.exists()){
			if(!dir.mkdirs()){
				return false;
			}
		}
		//s
		BufferedInputStream bis = new BufferedInputStream(new FileInputStream(before));
		BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(after));
		int b;
		while((b=bis.read())!=-1){
			bos.write((byte)b);
		}
		bis.close();
		bos.close();
		//
		return true;
	}
	//******************************************************************************************************
	//CxgiɉȂj
	//------------------------------------------------------------------------------------------------------
	public void printDataTransferCompleted(PrintJobEvent arg0) {
	}
	public void printJobCanceled(PrintJobEvent arg0) {
	}
	public void printJobCompleted(PrintJobEvent arg0) {
	}
	public void printJobFailed(PrintJobEvent arg0) {
	}
	public void printJobNoMoreEvents(PrintJobEvent arg0) {
	}
	public void printJobRequiresAttention(PrintJobEvent arg0) {
	}
}
