import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;


public class KanjiBlankPanel extends JPanel implements FocusListener,ActionListener,MouseListener,MouseMotionListener, KeyListener, ComponentListener,Printable
{
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//----------萔------------
	//ipuzzleModej
	static final int MODE_ANSWER=0;
	static final int MODE_EDIT=1;
	//
	static final int DEF_CELL=26;
	//----------ϐ------------
	//pY{
	KanjiBlankData puzzleData;
	//\Wn	
	KanjiBlankCoordinate co;
	//
	//
	int puzzleMode;
	//
	//f[^͗p
	JTextField inputField=new JTextField();
	int inputNum;	//oRdli0FIA̐FdA̐Fnj
	//
	int	cellSize;		//ڂ̃TCY
	int	baseX,baseY;	//`挴_
	//
	//\tO
	boolean errorViewFlag;
	boolean cursorViewFlag;
	//
	boolean draged;
	//
	//t[TCŶ
	JScrollPane scrollEdge;
	Dimension edgeMargin;
	//
	//pY{̂̃f[^ύX肩ǂijǑxpj
	boolean changed;
	KanjiBlankFrame frame;	//^CgύXp
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KanjiBlankPanel(KanjiBlankFrame frm){
		//
		puzzleData=new KanjiBlankData();
		co=new KanjiBlankCoordinate(puzzleData);
		//
		puzzleMode=MODE_ANSWER;
		//
		cellSize=DEF_CELL;
		//
		//\tO
		errorViewFlag=true;
		cursorViewFlag=true;
		//
		draged=false;
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		add(inputField);
		inputField.setVisible(false);
		inputNum=0;
		//
		changed=false;	//łsetChangedȂ
		frame=frm;
		//Cxg̐ݒ
		inputField.addFocusListener(this);
		inputField.addActionListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		addComponentListener(this);
	}
	//t[TCŶ߃XN[̈Ƃ̃TCY߂˂΂Ȃ
	public void setScrollEdge(JScrollPane scroll){
		scrollEdge=scroll;
		//
		edgeMargin=new Dimension(scrollEdge.getWidth()-getWidth(),scrollEdge.getHeight()-getHeight());
		if(edgeMargin.width==0 || edgeMargin.height==0){
			edgeMargin=new Dimension(3,3);		//炩̗RœȂWindowsł̒lɐݒ
		}
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	//wTCYŐVpY쐬
	public void formatPuzzle(int ht,int wd,int chMx){
		//
		puzzleData.formatPuzzle(ht, wd,chMx);
		co.setCoordinate();
		//I𒆂̃}X
		formatSelectedPos();
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		//f[^ύX͂܂Ȃ
		setChanged(false);
		//
		requestFocus();	//ȂĂ悤
	}
	//wTCYɕύX
	public void changePuzzle(int ht,int wd,int chMx){
		//
		String ret=puzzleData.changePuzzle(ht, wd,chMx);
		if(ret!=null){
			showErrorMessage(ret,"G[");
			//
			return;
		}
		//
		co.setCoordinate();
		//I𒆂̃}X
		formatSelectedPos();
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		//f[^ύX
		setChanged(true);
		//
		requestFocus();	//ȂĂ悤
	}
	//𓚏
	public void formatAnswer(){
		puzzleData.formatAnswer();
		//
		setChanged(true);
		//
		repaint();
	}
	//d̐
	public void removeOverlapChar(){
		/*
		//i𓚃[hłoHj
		if(puzzleMode!=MODE_EDIT){
			showInfoMessage("d͕ҏW[hōsĂB","");
			return;
		}*/
		//
		String ret=puzzleData.removeOverlapChar();
		if(ret==null){
			showInfoMessage("gpPƎgp̏d͂܂łB","d ");
			//
			return;
		}
		//idĂ邩Ȃ̂Łj
		co.setCoordinate();
		//I𒆂̃}X
		formatSelectedPos();
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		setChanged(true);
		//
		repaint();
		//
		showInfoMessage(ret,"d ");
	}
	//n̕ёւ
	public void sortWords(){
		puzzleData.sortWords();
		//
		co.setCoordinate();
		//I𒆂̃}X
		formatSelectedPos();
		//
		setChanged(true);
		//
		repaint();
	}
	//G[o
	public void checkQuestion(){
		/*
		//i𓚃[hłoHj
		if(puzzleMode!=MODE_EDIT){
			showInfoMessage("`FbN͕ҏW[hōsĂB","");
			return;
		}*/
		//
		puzzleData.detectError();
		//
		repaint();
		//
		showInfoMessage(puzzleData.getErrorInfo(),"`FbN ");
	}
	//G[폜
	public void removeError(){
		/*
		//i𓚃[hłoHj
		if(puzzleMode!=MODE_EDIT){
			showInfoMessage("`FbN͕ҏW[hōsĂB","");
			return;
		}*/
		//
		puzzleData.removeError();
		//
		repaint();
	}
	//I
	private void formatSelectedPos(){
		co.formatSelect();	//ŏ̈ʒu
	}
	//******************************************************************************************************
	//ݒύX
	//------------------------------------------------------------------------------------------------------
	public void changePuzzleMode(int mode){
		puzzleMode=mode;
		//L[{[ĥ߃tH[JX𓾂
		requestFocus();
		//
		repaint();
	}
	public void setErrorViewFlag(boolean f){
		errorViewFlag=f;
		//
		repaint();
	}
	public void setCursorViewFlag(boolean f){
		cursorViewFlag=f;
		//
		repaint();
	}
	public boolean checkChanged(){
		return changed;
	}
	public void setChanged(boolean f){
		changed=f;
		//AppletłȂ΃^CgŕύX̗LiZ[uA[hAVK̎ɂ͏dȂ邪j
		if(frame!=null){
			frame.setTitleString();
		}
	}
	public int getPuzzleWidth(){	//AppletDialog
		return co.wdW;
	}
	public int getPuzzleHeight(){	//AppletDialog
		return co.wdH+co.ovH;
	}
	//******************************************************************************************************
	//}XTCY
	//------------------------------------------------------------------------------------------------------
	public int getCellSize(){
		return cellSize;
	}
	public void setCellSize(int size){
		cellSize=size;
		//
		setPreferredPanelSize();
	}
	//}XTCYύXɃt[Ă΂AꎞIɃpl̃TCY}X̃TCYɍ킹i܂t[̃TCY͕ςj
	public void adjustPanelSize(){
		//XN[o[\Ă	[XN[̈pl]<[œKplTCY]
		//Ȃ							[XN[̈pl]>[œKplTCY]
		int w=Math.max(scrollEdge.getWidth()-edgeMargin.width,getPreferredSize().width);
		int h=Math.max(scrollEdge.getHeight()-edgeMargin.height,getPreferredSize().height);
		//pl̃TCYύXiXN[̈pl傫ȂΎŃXN[o[oj
		setSize(w,h);
	}
	//******************************************************************************************************
	//œKTCYE`挴_̒
	//------------------------------------------------------------------------------------------------------
	//œKplTCYݒ
	private void setPreferredPanelSize(){
		int preferredWidth=cellSize*(co.wdW+1 );
		int preferredHeight=cellSize*(co.wdH+co.ovH+1 );
		setPreferredSize(new Dimension(preferredWidth,preferredHeight));
		//`挴_ݒ
		setPaintBasePoint();
	}
	//`挴_iplTCYύXPƂŌĂ΂j
	private void setPaintBasePoint(){
		//
		Dimension d=getPreferredSize();
		if(getWidth()<=d.width){
			baseX=(cellSize>>1);
		}else{
			baseX=(cellSize>>1)+( (getWidth()-d.width)>>1 );
		}
		if(getHeight()<=d.height){
			baseY=(cellSize>>1);
		}else{
			baseY=(cellSize>>1)+( (getHeight()-d.height)>>1 );
		}
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//œKplTCYɑ΂āApl̕\Ă镔ǂꂾTCYߏ肩Ԃ
	//it[Ă΂At[ǂꂾ߂΃XN[o[\ɂނ̔fɎgj
	public Dimension getSizeDifference(){
		//XN[o[\Ă	[pl̈]>[XN[̈pl]
		//Ȃ							[pl̈]<[XN[̈pl]
		int w=Math.min(getWidth(),scrollEdge.getWidth()-edgeMargin.width)-getPreferredSize().width;
		int h=Math.min(getHeight(),scrollEdge.getHeight()-edgeMargin.height)-getPreferredSize().height;
		return new Dimension( w , h );
	}
	//摜ۑ̂߂̕`挴_ił͕`XP[ς\̂ňČvZj
	private Point getOutputBasePoint(int cell){
		return new Point(cell>>1,cell>>1);
	}
	//******************************************************************************************************
	//`
	//------------------------------------------------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//`挴_w肵ĕ`悳
		paintField(g,baseX,baseY,cellSize);
	}
	//摜ۑ̕`i`挴_͍ɋl߂WA`XP[͓j
	public void paintGraphic(Graphics g){
		Point base=getOutputBasePoint(cellSize);
		paintField(g, base.x, base.y,cellSize);
	}
	//̕`i`挴_͍ɋl߂WA`XP[͈\̈ɍ킹ďkj
	public int print(Graphics g, PageFormat fmt, int index) throws PrinterException {
		if(index>0){	//y[W1y[WɌŒ
			return NO_SUCH_PAGE;
		}else{
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//`XP[𒲐
			double pageW=fmt.getImageableWidth();
			double pageH=fmt.getImageableHeight();
			int fieldW=getPreferredSize().width;
			int fieldH=getPreferredSize().height;
			double ratioW=pageW/fieldW;		//̔{
			double ratioH=pageH/fieldH;		//̔{
			double ratio=1;
			int cell;
			if(ratioW<1 || ratioH<1){		//ƍǂ炩łk̕Kv
				ratio=(ratioW<ratioH)?ratioW:ratioH;	//k˂΂ȂȂ{I
				//
				cell=(int)(cellSize*ratio);
			}else{							//Sk̕KvȂ΂̂܂
				cell=cellSize;
			}
			//
			Point base=getOutputBasePoint(cell);	//k`XP[Ŏ擾
			paintField(g,base.x,base.y,cell);
			//
			return PAGE_EXISTS;
		}
	}
	//ėp̕`惁\bhi摜ۑɂgj
	private void paintField(Graphics g,int bx,int by,int cell){
		//tHgݒ
		Font normalFont=new Font( null, Font.PLAIN, cell);
		Font smallFont=new Font( null, Font.PLAIN, cell>>1);
		//wi
	    g.setColor(Color.white);
		g.fillRect(bx-(cell>>1), by-(cell>>1), getPreferredSize().width, getPreferredSize().height);
	    g.setColor(Color.black);
		g.drawRect(bx, by, cell*co.wdW, cell*co.wdH);
		//n
		for(int t=0;t<puzzleData.getTotalNum();t++){
			String word=puzzleData.words[t];
			int[] ovNum=puzzleData.overlapNum[t];
			//
			if(word.equals(String.valueOf(KanjiBlankData.CHAR_EMPTY))){		//f[^
				g.setColor(Color.lightGray);
				g.fillRect(bx+cell*co.wdX[t], by+cell*co.wdY[t], cell*puzzleData.charMax, cell);
			}else{															//f[^L
				for(int c=0;c<puzzleData.charMax;c++){
					if(ovNum[c]==KanjiBlankData.INT_NOT_OVERLAP){	//d
						g.setColor(Color.black);
						g.setFont(normalFont);
						g.drawString(word.substring(c, c+1), bx+cell*(co.wdX[t]+c), by+cell*(co.wdY[t]+1));
					}else if(ovNum[c]==KanjiBlankData.INT_NO_CHAR){	//Ō܂ŗ
						//̏n
						break;
					}else{											//d
						//}EXJ[\ɍ킹A̔ԍ̕\
						if(ovNum[c]==co.mouseOn){
						    g.setColor(Color.yellow);
							g.fillRect(bx+cell*(co.wdX[t]+c), by+cell*co.wdY[t], cell, cell);
						}
						//
						char ch=puzzleData.overlapChar.get(ovNum[c]-1);
						if(ch!=KanjiBlankData.CHAR_EMPTY){
							if(puzzleMode==MODE_EDIT){
							    g.setColor(Color.blue);
							}else{
							    g.setColor(Color.black);
							}
							g.setFont(normalFont);
							g.drawString(String.valueOf(ch), bx+cell*(co.wdX[t]+c), by+cell*(co.wdY[t]+1));
						}
						//Ɣԍ
					    g.setColor(Color.black);
						g.setFont(smallFont);
						g.drawLine(bx+cell*(co.wdX[t]+c)+1, by+cell*(co.wdY[t]+1), bx+cell*(co.wdX[t]+c+1)-2, by+cell*(co.wdY[t]+1));
						g.drawString(String.valueOf(ovNum[c]), bx+cell*(co.wdX[t]+c)+(cell>>2), by+cell*(co.wdY[t]+1)+(cell>>1));
					}
					
				}
			}
			
		}
		//d
		if(puzzleData.overlapChar.size()==0){		//f[^
		    g.setColor(Color.black);
			g.drawRect(bx, by+cell*co.wdH+(cell>>1), cell, (cell>>1) );
			g.drawRect(bx, by+cell*co.wdH+cell, cell, cell);
		}else{										//f[^L
			//}EXJ[\ɍ킹A̔ԍ̕\
			if(co.mouseOn!=0){
			    g.setColor(Color.yellow);
				g.fillRect(bx+cell*co.ovX.get(co.mouseOn-1), by+cell*co.ovY.get(co.mouseOn-1),cell,cell);
			}
			//
		    g.setColor(Color.black);
			for(int o=0;o<puzzleData.overlapChar.size();o++){
				//g
				g.drawRect(bx+cell*co.ovX.get(o), by+cell*co.ovY.get(o)-(cell>>1), cell, (cell>>1));
				g.drawRect(bx+cell*co.ovX.get(o), by+cell*co.ovY.get(o), cell, cell);
				//
				g.setFont(smallFont);
				g.drawString(String.valueOf(o+1), bx+cell*co.ovX.get(o)+(cell>>2), by+cell*co.ovY.get(o));
				//
				char ch=puzzleData.overlapChar.get(o);
				if(ch!=KanjiBlankData.CHAR_EMPTY){
					g.setFont(normalFont);
					g.drawString(String.valueOf(ch), bx+cell*co.ovX.get(o), by+cell*(co.ovY.get(o)+1));
				}
				
			}
		}
		//G[
		if(errorViewFlag){
			g.setColor(Color.red);
			for(int e=0;e<puzzleData.errors.size();e++){
				KanjiBlankError er=puzzleData.errors.get(e);
				//_
				if(er.pos1>0){
					g.drawRect(bx+cell*co.ovX.get(er.pos1-1),by+cell*co.ovY.get(er.pos1-1),cell,cell);
					g.drawRect(bx+cell*co.ovX.get(er.pos1-1)+1,by+cell*co.ovY.get(er.pos1-1)+1,cell-2,cell-2);
				}else if(er.pos1<0){
					g.drawRect(bx+cell*co.wdX[-er.pos1-1],by+cell*co.wdY[-er.pos1-1],cell*puzzleData.charMax,cell*2);
					g.drawRect(bx+cell*co.wdX[-er.pos1-1]+1,by+cell*co.wdY[-er.pos1-1]+1,cell*puzzleData.charMax-2,cell*2-2);
				}
				//_i΁j
				if(er.pos2>0){
					g.drawRect(bx+cell*co.ovX.get(er.pos2-1),by+cell*co.ovY.get(er.pos2-1),cell,cell);
					g.drawRect(bx+cell*co.ovX.get(er.pos2-1)+1,by+cell*co.ovY.get(er.pos2-1)+1,cell-2,cell-2);
				}else if(er.pos2<0){
					g.drawRect(bx+cell*co.wdX[-er.pos2-1],by+cell*co.wdY[-er.pos2-1],cell*puzzleData.charMax,cell*2);
					g.drawRect(bx+cell*co.wdX[-er.pos2-1]+1,by+cell*co.wdY[-er.pos2-1]+1,cell*puzzleData.charMax-2,cell*2-2);
				}
			}
		}
		//I𕔕̃J[\
		if(cursorViewFlag){
			if(puzzleMode==MODE_EDIT){
				g.setColor(Color.blue);
				//I𕔕
				int s=co.sel;
				if(s>0){			//d
					s=s-1;
					g.drawRect(bx+cell*co.ovX.get(s),by+cell*co.ovY.get(s),cell,cell);
					g.drawRect(bx+cell*co.ovX.get(s)-1,by+cell*co.ovY.get(s)-1,cell+2,cell+2);
				}else if(s<0){		//n
					s=-s-1;
					g.drawRect(bx+cell*co.wdX[s],by+cell*co.wdY[s],cell*puzzleData.charMax,cell*2);
					g.drawRect(bx+cell*co.wdX[s]-1,by+cell*co.wdY[s]-1,cell*puzzleData.charMax+2,cell*2+2);
				}else{				//IiŚj
					g.drawRect(bx-1, by-1, cell*co.wdW+2, cell*(co.wdH+co.ovH)+2);
					g.drawRect(bx-2, by-2, cell*co.wdW+4, cell*(co.wdH+co.ovH)+4);
				}
				//ړ
				int f=co.sel;
				int t=co.moveTo;
				if(t>0){			//d
					f=f-1;
					t=t-1;
					if(f<t){		//ւ̏ꍇ́A
						g.fillRect(bx+cell*(co.ovX.get(t)+1)-1, by+cell*co.ovY.get(t)-1, 2, cell+2);
					}else if(f>t){	//Oւ̏ꍇ́A
						g.fillRect(bx+cell*co.ovX.get(t)-1, by+cell*co.ovY.get(t)-1, 2, cell+2);
					}else{			//̂܂܂̏ꍇ́A\Ȃ
						//no work
					}
				}else if(t<0){		//n
					f=-f-1;
					t=-t-1;
					if(f<t){		//ւ̏ꍇ́A
						g.fillRect(bx+cell*co.wdX[t]-1, by+cell*(co.wdY[t]+2)-1, cell*puzzleData.charMax+2, 2);
					}else if(f>t){	//Oւ̏ꍇ́A
						g.fillRect(bx+cell*co.wdX[t]-1, by+cell*co.wdY[t]-1, cell*puzzleData.charMax+2, 2);
					}else{			//̂܂܂̏ꍇ́A\Ȃ
						//no work
					}
				}
			}
		}
	}
	//******************************************************************************************************
	//bZ[W\
	//------------------------------------------------------------------------------------------------------
	private void showInfoMessage(String message,String title){
		JOptionPane.showMessageDialog(this,	message,title,JOptionPane.INFORMATION_MESSAGE);
	}
	public void showErrorMessage(String message,String title){
		JOptionPane.showMessageDialog(this,	message,title,JOptionPane.ERROR_MESSAGE);
	}
	//******************************************************************************************************
	//Z[uE[h
	//------------------------------------------------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		String ret=puzzleData.setLoadString(ld);
		if(ret!=null){
			showErrorMessage(ret,"G[");
			//
			return false;
		}
		//
		co.setCoordinate();
		co.formatSelect();
		setPreferredPanelSize();
		//
		setChanged(false);
		//
		requestFocus();	//return false ȂȂĂ
		//
		return true;
	}
	public String getSaveString(boolean saveFlag){
		//
		requestFocus();
		//Z[upɌĂяoiAppleto͂ł͂ȂjȂ
		if(saveFlag){
			setChanged(false);
		}
		//
		return puzzleData.getSaveString();
	}
	//******************************************************************************************************
	//f[^͗pTextField
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		//
		if(e.getSource()==inputField){
			inputField.setVisible(false);
			//
			if(inputNum>0){				//d
				String ret=puzzleData.setOverlapChar(inputField.getText(), inputNum-1);
				if(ret!=null){
					showErrorMessage(ret,"G[");
					return;
				}
				//
				setChanged(true);
			}else if(inputNum<0){		//n
				String ret;
				if(puzzleMode==MODE_ANSWER){	//𓚃[h
					ret=puzzleData.setWordAnswer(inputField.getText(), -inputNum-1);
					if(ret!=null){
						showErrorMessage(ret,"G[");
						return;
					}
				}else{							//ҏW[h
					ret=puzzleData.setWordEdit(inputField.getText(), -inputNum-1);
					if(ret!=null){
						showErrorMessage(ret,"G[");
						return;
					}
					//dĂ邩Ȃ
					co.setCoordinate();
					//co.formatSelect();
					setPreferredPanelSize();
				}
				//
				setChanged(true);
			}
			//
			repaint();
			//
			requestFocus();
		}
	}
	//******************************************************************************************************
	//tH[JXCxg
	//------------------------------------------------------------------------------------------------------
	public void focusGained(FocusEvent e) {}
	public void focusLost(FocusEvent e) {
		//f[^͗tH[JXΉB
		if(e.getSource()==inputField){
			inputField.setVisible(false);
		}
	}
	//******************************************************************************************************
	//}EXCxg
	//------------------------------------------------------------------------------------------------------
	//ړs
	public void mouseReleased(MouseEvent e){
		//
		if(puzzleMode==MODE_EDIT){
			int to=co.moveTo;
			int from=co.sel;
			//
			if(to!=0 && to!=from){
				if(to>0){		//d
					from=from-1;
					to=to-1;
					puzzleData.moveOverlapChar(from, to);
					//
					co.shiftSelect();
					co.setCoordinate();
					//
					setChanged(true);
				}if(to<0){		//n
					from=-from-1;
					to=-to-1;
					puzzleData.moveWord(from, to);
					//
					co.shiftSelect();
					co.setCoordinate();
					//
					setChanged(true);
				}else{			//I
					//
				}
			}
			//
			co.resetMoveTo();
		}
		//
		draged=false;
		//
		repaint();
	}
	//no work
	public void mouseEntered(MouseEvent e){}
	//Ԃ̉
	public void mouseExited (MouseEvent e){
		//
		co.resetMoveTo();
		//
		draged=false;
		//
		repaint();
	}
	//vf̈ړ
	public void mousePressed(MouseEvent e){
		//}Xʒu
		int x=(e.getX()-baseX)/cellSize;
		int y=(e.getY()-baseY)/cellSize;
		//
		co.setSelect(x, y);
		//
		draged=true;
		//
		repaint();
		//ŃtH[JX𓾂̂ŁAł͕svif[^͗tH[JXDj
		requestFocus();
	}
	//f[^
	public void mouseClicked(MouseEvent e){
		//}Xʒu
		int x=(e.getX()-baseX)/cellSize;
		int y=(e.getY()-baseY)/cellSize;
		//
		showInputField(co.mouseClick(x, y));
		//ĕ`
		repaint();
	}
	//͗̏ꏊɕ\iEnterL[łĂ΂j
	private void showInputField(int n){
		//ǂ̍ڂ͐悩ێiI𕔕̓L[ňړĂ܂\j
		inputNum=n;
		//
		if(inputNum>0){				//d
			inputField.setBounds(baseX+cellSize*co.ovX.get(inputNum-1),baseY+cellSize*co.ovY.get(inputNum-1),cellSize,cellSize);
			inputField.setText(puzzleData.getOverlapChar(inputNum-1));
			inputField.setVisible(true);
			//
			inputField.requestFocus();
		}else if(inputNum<0){		//n
			inputField.setBounds(baseX+cellSize*co.wdX[-inputNum-1],baseY+cellSize*co.wdY[-inputNum-1],cellSize*(puzzleData.charMax+1),cellSize);
			inputField.setText(puzzleData.getWords(-inputNum-1));
			inputField.setVisible(true);
			//
			inputField.requestFocus();
		}else{						//IiŚj
			//itH[JXf[^͗̑PressɍŝŁAł͕svj
		}
	}
	//vf̈ړ
	public void mouseDragged(MouseEvent e) {
		//}Xʒu
		int x=(e.getX()-baseX)/cellSize;
		int y=(e.getY()-baseY)/cellSize;
		//ҏW[ĥ
		if(draged && puzzleMode==MODE_EDIT){
			co.mouseDrag(x, y);
		}
		//ĕ`
		repaint();
	}
	//}X\
	public void mouseMoved(MouseEvent e) {
		//}Xʒu
		int x=(e.getX()-baseX)/cellSize;
		int y=(e.getY()-baseY)/cellSize;
		//
		co.mouseMove(x, y);
		//ĕ`
		repaint();
	}
	//******************************************************************************************************
	//L[Cxg
	//------------------------------------------------------------------------------------------------------
	public void keyReleased(KeyEvent e){}
	public void keyTyped(KeyEvent e){}
	public void keyPressed(KeyEvent e){
		//
		switch(e.getKeyCode()){
		case KeyEvent.VK_SHIFT:		//SHIFT
			co.changeSelectArea();
			break;
		case KeyEvent.VK_ENTER:		//ENTER
			showInputField(co.sel);
			break;
		case KeyEvent.VK_UP:		//
			co.up();
			break;
		case KeyEvent.VK_DOWN:		//
			co.down();
			break;
		case KeyEvent.VK_RIGHT:		//E
			co.right();
			break;
		case KeyEvent.VK_LEFT:		//
			co.left();
			break;
		default:
		}
		repaint();	//ĕ`
	}
	//******************************************************************************************************
	//	R|[lgCxgitB[h̑傫ύX擾j
	//------------------------------------------------------------------------------------------------------
	public void componentHidden(ComponentEvent arg0) {
	}
	public void componentMoved(ComponentEvent arg0) {
	}
	public void componentResized(ComponentEvent e) {
		setPaintBasePoint();	//pl̃TCYςΕ`挴_Đݒ
	}
	public void componentShown(ComponentEvent arg0) {
	}
}
